/***************************************************************************
                          kmms.cpp  -  description
                             -------------------
    begin                : Mon Mar  5 16:18:00 CET 2001
    copyright            : (C) 2001 by Janosch Rolles
    email                : janosch@base2.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kglobal.h>
#include <klocale.h>
#include <kconfig.h>
#include <kapp.h>
#include <kmessagebox.h>

#include "kmms.h"

extern "C"
{
  KPanelApplet* init( QWidget *parent, const QString configFile)
  {
    KGlobal::locale()->insertCatalogue("kmms");
    return new Kmms(configFile, KPanelApplet::Normal,
                      KPanelApplet::About | KPanelApplet::Help | KPanelApplet::Preferences,
                      parent, "kmms");
  }
}

Kmms::Kmms(const QString& configFile, Type type, int actions, QWidget *parent, const char *name )
       : KPanelApplet(configFile, type, actions, parent, name )
{
  // Get the current application configuration handle
  ksConfig = config();
  mainView = new kmmsdock(this);
  mainView->initialize(VERSION);
  mainView->show();
}

Kmms::~Kmms()
{
}

void Kmms::about()
{
   KMessageBox::information(0, i18n("This is KMMS (Kde MultiMedia System) version "VERSION"\nwritten by Janosch Rolles <janosch@base2.de>.\nKDE 3 version and minor updates by Luiz Paulo M. Pires.\nFor additional information and other\nmp3 related tools view http://www.base2.de"));
}

void Kmms::help()
{
   KMessageBox::information(0, i18n("Integrated online help is not (yet?) available.\nView README file for (and ChangeLog for very current)\ninformation and visit http://www.base2.de"));
}

void Kmms::preferences()
{
	//KMessageBox::information(0, i18n("This is a preferences box"));
	mainView->prefsPopup();
}

int Kmms::widthForHeight( int height ) const
{
	return mainView->widthForHeight(height);
}

int Kmms::heightForWidth( int width ) const
{
	return mainView->heightForWidth(width);
}

void Kmms::resizeEvent( QResizeEvent *event)
{
   
}
