/***************************************************************************
                          kmmsprefsImpl.h  -  description
                             -------------------
    begin                : Wed Mar 07 2001
    copyright            : (C) 2001 by Janosch Rolles
    email                : janosch@base2.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef KMMSPREFSIMPL_H
#define KMMSPREFSIMPL_H



#include "kmmsprefs.h"


#include <qcheckbox.h>
#include <qcolor.h>
#include <kcolorbutton.h>


class kmmsprefsImpl : public kmmsprefs
{ Q_OBJECT

public:
    kmmsprefsImpl( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags f = 0 );

public slots:
    bool getPrefs(QColor* titleColor, QColor* osdColor, bool* clearPlaylistOnDrop, bool* autoPlayAddedSongs);

signals:

protected:

private:
		bool saveChanges;

		/* Preferences Variables (pointers to parent class) */
		QColor* titleColorPt;
		QColor* osdColorPt;
		bool* clearPlaylistOnDropPt;
		bool* autoPlayAddedSongsPt;

		/* Preferences Backups */
		QColor titleColorBak;
		QColor osdColorBak;
		bool clearPlaylistOnDropBak;
		bool autoPlayAddedSongsBak;

private slots:
    void backupValues();
    void restoreValues();

    void initializeWidget();
    void askWidget();

		void titleColorButtonImpl(const QColor&);
		void osdColorButtonImpl(const QColor&);

};


#endif
